#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;
typedef double ld;

#define EPS (1e-10)
#define EQ(a,b) (fabs(a-b) <= fabs(a+b) * EPS)
#define DEB(...) cerr<<#__VA_ARGS__<<": "<<__VA_ARGS__<<endl

struct Pt{
    ld x,y;
    bool operator <(const Pt &p) const {
        return x < p.x || x == p.x && y < p.y;
    }
    Pt operator-(){return{-x,-y};}
    Pt operator+(const Pt&p){return{x+p.x,y+p.y};}
    Pt operator-(const Pt&p){return{x-p.x,y-p.y};}
    Pt operator*(ld d){return {x*d,y*d};}
    Pt operator/(ld d){return {x/d,y/d};}
    friend ostream &operator<<(ostream &os, const Pt&a){
        os<<a.x<<' '<<a.y;
        return os;
    }
    friend istream &operator>>(istream &is, Pt&a){
        is>>a.x>>a.y;
        return is;
    }
};
struct Line {
    Pt a,b;
    Line(Pt a,Pt b):a(a),b(b){}
    bool operator<(Line &l){
        Pt v=b-a,w=l.b-l.a;
        return atan2(v.y, v.x) < atan2(w.y, w.x);
    }
};
struct Cir {
    Pt s;
    ld r;
    Pt point(double a)const{return {s.x+cos(a)*r,s.y+sin(a)*r};}  
    bool operator<(const Cir& a){return r<a.r;}  
};

ld vec(Pt a, Pt b){ return a.x*b.y-a.y*b.x; }
ld vec(Pt a, Pt b, Pt c){ return vec(b-a,c-a); }
ld dot(Pt a, Pt b){ return a.x*b.x+a.y*b.y; }
ld norm(Pt a){ return sqrt(dot(a,a)); }
ld points_distance(Pt a, Pt b){ return norm(b-a); }

bool in_circle(Pt &a,Cir &c){
    return points_distance(a,c.s)<c.r;
}

int main(){
    srand(time(NULL));
    Cir c;cin>>c.s>>c.r;
    Pt a,b;cin>>a>>b;
    if(a.x>b.x)swap(a.x,b.x);
    if(a.y>b.y)swap(a.y,b.y);
    // normalize coordinates so that the center of the circle is on (0,0)
    a=a-c.s;
    b=b-c.s;
    c.s={EPS,EPS};
    // construct the full rectangle
    const ll mx=1ll<<30;
    const ld prec=1e-6;
    ld change=1;
    ll pos=0,total=0;
    ld last,cur=2;
    Pt vr=b-a;
    ld area=(b.x-a.x)*(b.y-a.y);
    do{
        ld xr = (rand()%mx)/(ld)mx;
        ld yr = (rand()%mx)/(ld)mx;
        Pt rnd_pt=a+vr*xr;
        pos+=in_circle(rnd_pt,c);
        ++total;
        last=cur;
        cur=pos/(ld)total;
        change=change*0.8+abs(cur-last)*0.2;
        //cerr<<rnd_pt<<' '<<cur<<' '<<change<<endl;
    }while(total<10000 || change*area>prec);
    cout<<fixed<<setprecision(12);
    cout<<cur*area<<endl;
    return 0;
}

